﻿using System;

class Shape // the parent class
{
    private double width; // invisible to the outside world
    protected double radius; // should be moved to class Circle
    protected double length; // should probably be moved to class Square?

    public Shape()
    {
        length = width = radius = 0.0;
    }

    public Shape(double l, double w, double r)
    {
        length = l;
        width = w;
        radius = r;
        Console.WriteLine("Shape::Shape");
    }

    public virtual double CalculateArea()
    {
        return length * width;
    }

    ~Shape()
    {
        Console.WriteLine("Shape::~Shape");
    }
}

class Square : Shape // a child class
{
    public Square(double l, double w, double r) : base(l, w, r)
    {
        Console.WriteLine("Square::Square");
    }

    public override double CalculateArea()
    {
        return length * length;
    }

    ~Square()
    {
        Console.WriteLine("Square::~Square");
    }
}

class Circle : Shape // a child class
{
    public Circle(double l, double w, double r) : base(l, w, r)
    {
        Console.WriteLine("Circle::Circle");
    }

    public override double CalculateArea()
    {
        const double PI = 3.14;
        return PI * radius * radius;
    }

    ~Circle()
    {
        Console.WriteLine("Circle::~Circle");
    }
}

class Rectangle : Shape // a child class
{
    public Rectangle(double l, double w, double r) : base(l, w, r)
    {
        Console.WriteLine("Rectangle::Rectangle");
    }

    ~Rectangle()
    {
        Console.WriteLine("Rectangle::~Rectangle");
    }
}

class Program
{
    static void Main()
    {
        Circle circle = new Circle(0, 0, 7.0);
        Square square = new Square(6.0, 0, 0);
        Rectangle rectangle = new Rectangle(5.0, 4.0, 0);

        Console.WriteLine("The area of the circle is " + circle.CalculateArea());
        Console.WriteLine("The area of the square is " + square.CalculateArea());
        Console.WriteLine("The area of the rectangle is " + rectangle.CalculateArea());
    }
}
